unit dmu;

interface

uses
  SysUtils, Classes, UnixCrypt, FIBQuery, pFIBQuery, FIBDatabase,
  pFIBDatabase;
type
  Tdm = class(TDataModule)
    UnixCrypt1: TUnixCrypt;
    pFIBDB: TpFIBDatabase;
    pFIBTrans: TpFIBTransaction;
    pFIBQ: TpFIBQuery;
    procedure DataModuleCreate(Sender: TObject);
  private
    FLastLogin: TDateTime;
    FPerms: integer;
    FUid: integer;
    FUname: string;
    FDefPerms: integer;
    FDefPwd: string;
    FTblName: string;
    procedure SetLastLogin(const Value: TDateTime);
    procedure SetPerms(const Value: integer);
    procedure SetUid(const Value: integer);
    procedure SetUname(const Value: string);
    procedure SetDefPerms(const Value: integer);
    procedure SetDefPwd(const Value: string);
    procedure SetTblName(const Value: string);
  private
    { Private declarations }
  public
    { Public declarations }
    property Uname: string read FUname write SetUname;
    property Perms: integer read FPerms write SetPerms;
    property Uid: integer read FUid write SetUid;
    property LastLogin: TDateTime read FLastLogin write SetLastLogin;
    property DefPwd: string read FDefPwd write SetDefPwd;
    property DefPerms: integer read FDefPerms write SetDefPerms;
    property TblName: string read FTblName write SetTblName;
  end;

var
  dm: Tdm;

implementation
uses ucryptdemou,inifiles,forms,dialogs;
{$R *.dfm}

{ Tdm }

procedure Tdm.SetDefPerms(const Value: integer);
begin
  FDefPerms := Value;
end;

procedure Tdm.SetDefPwd(const Value: string);
begin
  FDefPwd := Value;
end;

procedure Tdm.SetLastLogin(const Value: TDateTime);
begin
  FLastLogin := Value;
end;

procedure Tdm.SetPerms(const Value: integer);
begin
  FPerms := Value;
  fucryptdemo.checkperms;
end;

procedure Tdm.SetUid(const Value: integer);
begin
  FUid := Value;
end;

procedure Tdm.SetUname(const Value: string);
begin
  FUname := Value;
end;

procedure Tdm.DataModuleCreate(Sender: TObject);
var
  ini: TIniFile;
begin
  ini:= TIniFile.Create(ChangeFileExt( Application.ExeName,'.ini')) ;
     try
     pFIBDB.AliasName:=ini.ReadString('DATABASE','ALIASNAME','');
     pFIBDB.DBName:=ini.ReadString('DATABASE','DBName','');
     pFIBDB.Connected:=true;
     finally
     FreeAndNil(ini);
     end;
end;

procedure Tdm.SetTblName(const Value: string);
begin
  FTblName := Value;
end;

end.
