unit loginu;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, dmu;

type
  TfLogin = class(TForm)
    Label1: TLabel;
    edUserLogin: TEdit;
    Label2: TLabel;
    edPasswordLogin: TEdit;
    btnLogin: TButton;
    btnCancel: TButton;
    procedure btnLoginClick(Sender: TObject);
    procedure edUserLoginKeyPress(Sender: TObject; var Key: Char);
    procedure edPasswordLoginKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fLogin: TfLogin;

implementation

uses ChangePwdu;
{$R *.dfm}

procedure TfLogin.btnLoginClick(Sender: TObject);
begin
  with dm.pFIBQ do
    begin
    Close;
    SQL.Clear;
    //get user record
    SQL.Add('select * from USERS where USERNAME = ''' + edUserLogin.Text +'''');
    dm.pFIBTrans.Active:=true;  //begin transaction
    ExecQuery;
    if not eof then  // If username found
      begin
      // encrypt password and compare to stored encrypted password
     // set salt to first 2 chars of username 
      dm.UnixCrypt1.Salt:=copy(edUserLogin.Text,1,2); 
      dm.UnixCrypt1.Key:=edPasswordLogin.Text;  //set Key to password entered
      //test Result against stored encrypted password
      if dm.UnixCrypt1.Result = Fields[2].AsString then  //login success
        begin
        //set variables for this user session
        dm.Uname:=Fields[1].AsString;
        dm.Perms:=Fields[3].AsInteger;
        dm.Uid:=Fields[0].AsInteger;
        dm.LastLogin:=now;
        Close;
        SQL.Clear;
        //save lastlogintime
        SQL.Add('update USERS set LASTLOGIN = :LOGIN where USERNAME = :USER_NAME');
        ParamByName('LOGIN').AsDateTime:=dm.LastLogin;
        ParamByName('USER_NAME').AsString := dm.Uname;
        dm.pFIBTrans.Active:=true;
        ExecQuery; 
        with Database.DefaultTransaction do
          if InTransaction then 
            Commit;
        Close;  
        if edPasswordLogin.Text = 'password' then  
          self.ModalResult:=mrRetry //if first login of new user
          else self.ModalResult:=mrOK;  // login success
        end  
        else  
          self.ModalResult:=mrCancel; // login failed
      end;
    end;
    
end;

procedure TfLogin.edUserLoginKeyPress(Sender: TObject; var Key: Char);
begin
  btnLogin.Enabled:=(length(edUserLogin.Text) > 0) and (Length(edPasswordLogin.Text) > 0);
end;

procedure TfLogin.edPasswordLoginKeyPress(Sender: TObject; var Key: Char);
begin
  btnLogin.Enabled:=(length(edUserLogin.Text) > 0) and (Length(edPasswordLogin.Text) > 0);
end;

procedure TfLogin.FormShow(Sender: TObject);
begin
  edUserLogin.Clear;
  edPasswordLogin.Clear;
end;

procedure TfLogin.btnCancelClick(Sender: TObject);
begin
   ModalResult:=mrCancel;
end;

end.
